// Lab Batch 75
// Project - BASIC BANKING APPLICATION SOFTWARE



#include<iostream>
#include<fstream>
#include<cstring>
#include<string>
#include<cstdio>
#include<cstdlib>

#define maxval 100

using namespace std ;

	// structure of the acc holder's detais
	// each variable holds 6 entities
	// a total of (4+20+20+4+100+8)=160 bytes

struct acc_holder 
{
	int acc_no ;
	char first_name[20], last_name[20];
	int age ;
	char address[100] ;
	float balance ;
}user_details[maxval];

int no_acc ;

// ---------------------	Function Initializations		------------------------
	
int password_chk() ;	
void start() ;
void main_menu() ;
int create_acc() ;
void deposit() ;
void withdrawal() ;
void bal_inquiry() ;
void del_acc();
void finish();

// ---------------------	Main Function Starts		-------------------------
				
int main()
{	
	int i=0, n=5, j ;
	int fraud=0 ;	
			
	fraud=password_chk() ;						// Checking the password
	if(fraud)
	{	
		cout<< "Terminating Program.\n\n" ;
		return 0 ;
	}
	start() ;									// Once Employee logs in, the 'records.txt' is tranferred to struct user_details[] 
		
	main_menu() ;								// Showing the main menu and correspondingly calling the rest of the functions
	
	finish() ;									// Once Employee logs out, the 'records.txt' is updated
	
	return 1;
}

// -----------------	Main Function Ends		-----------------------

// -----------------	Function Definitions	-----------------------

// -----------------			#0.				-----------------------


int password_chk()
{	
	string empname, emppassword ;
	int chk=0 ;
	start:
	cout<< "\nEmployee Name : " ;
	cin >> empname ;
	cout<< "Password : " ;
	cin >> emppassword ;

		// Check whether the person is a bank employee or not
		
	if(emppassword!="1234")
	{	
		cout<< "Incorrect password.\n\n" ;
		chk++ ;
		if(chk>2)
		{
			cout<< "\nWrong Password entered thrice.\n" ;
			return 1 ;
		}
		goto start;
	}
	return 0 ;
	
		// returns 1 if incorrect password is entered thrice, ow. return 0
}




// -----------------			#1.				-----------------------


void start()
{
	int i=0;
	FILE *frec;
												//Opening the txt file in reading mode 

	frec=fopen("records.txt","r");  	
	while(!feof(frec)&&i<maxval)
	{
				//Reading each element of the row differntly as....
	
		fscanf(frec,"%d",&user_details[i].acc_no);    			//integer
	
		fscanf(frec,"%s",&user_details[i].first_name);			//character
	
		fscanf(frec,"%s",&user_details[i].last_name);			//character
	
		fscanf(frec,"%s",&user_details[i].address); 			//character
	
		fscanf(frec,"%d",&user_details[i].age);					//integer 
	
		fscanf(frec,"%f",&user_details[i].balance);				//float
	
		i++;
	}
	no_acc=i-1 ;
	cout<< endl << "\nNumber of accounts : " << no_acc << endl ;

				//Closing the file pointer 

	fclose(frec);
	
				//Removing the records file so that after the day's work the updated file can be written in the newly made "records.txt" file.
		 
	if( remove( "records.txt" ) != 0 )
    	perror( "\nNo records available" );
	else
    	puts( "\nReceived records" );
}


// -----------------			#2.				-----------------------

void main_menu()
{
	char choice ;
	int i,flag=1,a ;	
	

	do
	{		
		printf("\n\n\n\n \t\t\t\t \t\t\tHamara Bank\n\n") ;
		cout<< "\t\t\tWelcome\n" ;
		cout<< "\n\t\t\t1. Create an Account" 
			<< "\t\t\t\t\t2. Deposit"
			<< "\n\t\t\t3. Withdrawal       "
			<< "\t\t\t\t\t4. Balance Inquiry"
			<< "\n\t\t\t5. Payment          "
			<< "\t\t\t\t\t6. Close an Account"
			<< "\n\n\t\t\t7. Exit\n" 
			<< "\nEnter the option : " ;
		cin >> choice ;
		cout<< "\n\n\n" ;
		
			
		switch(choice)
		{	case '1':
				a=create_acc() ;				
				break ;
			case '2':
				deposit() ;
				break ;
			case '3':
				withdrawal() ;
				break ;
			case '4':
				bal_inquiry() ;
				break ;
			case '5':
				cout<< "payment() not yet activated." ;
				break ;
			case '6':
				del_acc();
				break ;
			case '7':
				flag=0;
				break ;
			default:
				cout<< "\nWrong Option. Enter a no between 1-7.\n" ;
		
			cout<< endl << endl ;
		}
	}while(flag) ;

}



// -----------------			#2.1				-----------------------

int create_acc()
{
	int j ;
	j=no_acc ;
	
	cout<< "\nEnter the first name : \t " ;
	cin >> user_details[j].first_name ;
	cout<< "\nEnter the last name : \t " ;
	cin >> user_details[j].last_name ; 
	
	start:
	cout<< "\nEnter the age : \t " ;
	cin >> user_details[j].age ;
	
	if(user_details[j].age<18)	// Checking for minimum age 
	{
		cout<< "\nThe person is not eligible. She/He should be 18 or older.\n" ;
		goto start ;
	}
				 
	start1:
	cout<< "\nEnter the amount to be deposited : " ;
	cin >> user_details[j].balance ;
	
								// Checking for proper balance
	if(user_details[j].balance<500.00||user_details[j].balance>5000000.00)
	{
		cout<< "\nPlease deposit an amout between 500 and 50,00,000.\n" ;
		goto start1 ;
	}
          
	cout<< "\nEnter the address (Put an underscore for space) :\n\t\t" ;
	cin >> user_details[j].address ;
	
								// Generating the account no
	user_details[j].acc_no = user_details[j-1].acc_no+1 ;						
	cout<< "\n\nThank You for opening an account with us.\nYour account number is : \t " 
		<< user_details[j].acc_no 
		<< "\n\n" ;  
	
	no_acc++ ;					// Updating the total no of accounts
	 
	return 1;
}




// -----------------			#2.2				-----------------------

void deposit()
{
	indicator1:
	int k=-1, acc_search, depos=0, i=0, l ;
	char chk ;
	
	cout<< "Enter the Account no : " ; 
	cin >> acc_search; 								// To deposit in this account
	cout<< endl;		
	
	while(i<no_acc)
	{
		if(acc_search==user_details[i].acc_no)		// To search the account exists or not 
		{	k=i ;
			break ;
		}
		i++ ;									
	}

	if(k==-1)										// Account does not exist
	{
		cout<< "You have entered a wrong account number." ;
		indicator2:
		cout<< "If you want to enter again press 1\n"
			<< "If you want to go main menu press 2" << endl ; 
		cin >> l ;
		if(l==1)
			goto indicator1;						// To enter account no again
		else if(l==2)
			main_menu();								// To go to main manu 
		else
		{
			cout<< "Please press 1 or 2.\n" ;
			goto indicator2 ;						// Employee have to enter right choice
		}
	}
	else	
	{	
							//To show the account details of account holder

		cout<< "\nAccount no : " << user_details[k].acc_no ;
		cout<< "\nName       : " << user_details[k].first_name << " " << user_details[k].last_name ;
		cout<< "\nAge        : " << user_details[k].age ;
		cout<< "\nBalance    : " << user_details[k].balance << endl;

							//To deposit in the account
		flag1:
		cout<< "\nHow much do you want to deposit : " ;
		cin >> depos ;
		
							// Checking whether employee has entered correctly or not								

		cout<< "\nEntered amount : \t " << depos 
			<< "\nIf wrongly entered, press 0\n\tOtherwise, press 1   : \t " ;
		cin >> chk ;
		if(chk==48)	goto flag1 ;
					
														
		user_details[k].balance = user_details[k].balance+depos ;						// To update the accout database
		cout<< "Your updated new balance is " << user_details[k].balance << endl ;		// To show the new balance...
	}
	
}



// -----------------			#2.3				-----------------------

void withdrawal()
{	
	int acc_no, i=0, valid=0 ;
	int amount ;
	char chk ;
	cout<< "\n\t\t\t\tWithdrawal from an Account\n" ;
	
	flag2:
	cout<< "\n\nEnter the Acc no : " ;
	cin >> acc_no ;
	
						// Checking whether employee has entered correctly or not					

	cout<< "\nEntered acc_no : " << acc_no 						
		<< "\nIf wrongly entered, press 0 else, press any key : " ;
	cin >> chk ;
	if(chk==48)	goto flag2 ;
	
	while(user_details[i].acc_no&&(!valid))
	{	
						// Searching for the account
						
		if(user_details[i].acc_no==acc_no)				
		{	
						// Showing details of the account holder

			cout<< "\nThe details of the account holder are :\n"
				<< "\n\tName    :  " << user_details[i].first_name << " " << user_details[i].last_name
				<< "\n\tAge     :  " << user_details[i].age
				<< "\n\tBalance :  " << user_details[i].balance ;
			flag:
			cout<< "\n\nEnter the amount to be withdrawn : \t " ;
			cin >> amount ;
			
						// Checking whether employee has entered correctly or not
			cout<< "\nEntered amount : \t " << amount 
				<< "\nIf wrongly entered, press 0\n\t\tElse, press 1   : \t " ;
			cin >> chk ;
			if(chk==48)	goto flag ;
					
						// Checking whether customer has enough money to withdraw or not
			if(amount>(user_details[i].balance-500))		
			{	
				cout<< "\nCan not be withdrawn."
					<< "\nMust keep at least Rs 500 in your account.\n" 
					<< "\nGoing to Main Menu." ;
				break ;
			}
			
						// Balance withdrawn & updated
			else
			{
				user_details[i].balance-=amount ;
				cout<< "\nAmount can be withdrawn.\n"
					<< "\nUpdated balance : \t " << user_details[i].balance << "\n\n" ;
			}
						
			valid=1 ;					// Account has been found
		}
		i++ ;
	}
	
	if(!valid)							// If account does not exist
	{
		cout<< "\nEntered account does not exist."
			<< "\nGoing to main menu.\n\n\n" ;
	}
	
}


// -----------------			#2.4				-----------------------


void bal_inquiry()
{
	indicator3:
	int k=-1, acc_search, i=0, l ;
	
	cout<< "Enter the Account no : " ; 
	cin >> acc_search ; 								// To search for the account
	cout<< endl ;		
	
	while(i<no_acc)
	{
		if(acc_search==user_details[i].acc_no)			// To search the account exists or not 
		{	k=i ;
			break ;
		}
		i++ ;									
	}


	if(k==-1)									//Account does not exist
	{
		cout<< "You have entered a wrong account number.";
		cout<< "To retry press 0\n"
			<< "To re-enter press any other number : \t" ;
		cin >> l ;
		if(l==0)
			goto indicator3 ;					//To enter account no again
		else 
			exit(0);							//To go to main manu 
		
	}
	else	
	{
		//To show the account details of account holder
 			
		cout<< "\nThe details of the account holder are :\n"
			<< "\n\tName    : " << user_details[i].first_name << " " << user_details[i].last_name
			<< "\n\tAge     : " << user_details[i].age
			<< "\n\tBalance : " << user_details[i].balance ;
	
	
	}
	
}


//-------------			#2.6			-----------------------


void del_acc()
{ 
  int account_no,i=0,valid=0,k;
  char chk,ans;
 
  flag2:
   cout<<"Enter the account number to be deleted : ";
   cin>>account_no;
   cout<< "\nEntered acc_no : " << account_no; 						
   cout<< "\nIf wrongly entered, press 0 else, press any key : "<<endl ;
	cin >> chk ;
	if(chk==48)	goto flag2 ;
	
	while(user_details[i].acc_no&&(!valid))
	{	
						// Searching for the account
						
		if(user_details[i].acc_no==account_no)				
		   {	
						// Showing details of the account holder

			     cout<< "\nThe details of the account holder are :\n"
				  << "\n\tName    :  " << user_details[i].first_name << " " << user_details[i].last_name
				  << "\n\tAge     :  " << user_details[i].age
				  << "\n\tBalance :  " << user_details[i].balance ;
			
			   cout<< "\n\nAre you sure you want to delete the account?  \t " <<"\nIf yes press 1. Otherwise press 0  "<<endl;
			    cin >> ans ;
			
						
				
			     if(ans==48)	
			      main_menu();
			
			     else
			          { for( k=i;k<no_acc-1;k++)
			              { strcpy(user_details[k].first_name,user_details[k+1].first_name);
			                strcpy(user_details[k].last_name,user_details[k+1].last_name);
			                user_details[k].age=user_details[k+1].age;
			                user_details[k].balance=user_details[k+1].balance;
			                strcpy(user_details[k].address,user_details[k+1].address);
			                user_details[k].acc_no=user_details[k+1].acc_no;
			              } 
			              
					     cout<<"Your account has been deleted!"<<endl;
			           no_acc=no_acc-1;				
			           valid=1 ;					// Account has been found
		             }
		     
	        }
	        i++;
	        
	    }    
	
	   if(!valid)							// If account does not exist
	    {
		cout<< "\nEntered account does not exist."
			<< "\nGoing to main menu.\n\n\n" ;
	    }
	
  
  
}  

         



// -----------------			#n.				-----------------------


				//To creat a new file "records.txt" and store the updated data in it

void finish()
{	FILE *frec;

				//Creating a file to store the updated data 

	frec=fopen("records.txt","w+");
	int i=0;

				//Writing the updated records in records.txt

	while(i<no_acc)
 	{
	 	fprintf(frec,"%d %s %s %s %d %6.2f\n", user_details[i].acc_no, user_details[i].first_name, user_details[i].last_name, user_details[i].address, user_details[i].age, user_details[i].balance);
 	
	 	i++;
 	}
	cout<<"\nData updated\n"; 	

				//Closing the file pointer 

	fclose(frec);

}


